
<template>
<div>
  <h1>Olvide mi contraseña</h1>
  <div v-if="user != null">
    <h4>{{user.username}}</h4>

    <label>Nueva contraseña</label>
    <input placeholder="Introduzca su nueva contraseña" v-model="password">   
    <label>PIN (código)</label>
    <input placeholder="Introduzca su código" v-model="pin">   
    <button v-on:click="submit">Aceptar</button>
    <button v-on:click="resendConfirmationCode">Reenviar código</button>
    <label v-html="message" class="error"></label>
 </div>
  <div v-else>
    <label>Para realizar esta acción es necesario inicar sessión</label>
    <button v-on:click="goToLogin">Login</button>
  </div>
</div>
</template>
<style scoped>

.error{
  color: red;
  font-weight: bolder;
}
</style>

<script>
/**
 * @copyright       T-Systems México S.A. de C.V
 * @description     Reset/Olvide mi contraseña
 * @author          Roberto Pérez Guzmán
 * @creationDate    30 de septiembre del 2020
 */

import { mapGetters } from 'vuex'

let self = null;
export default {
 data() {
    self = this;
    return {
      pin:'',
      password:'',
      message: '.....',
      messageFn: null
    }
  },
  computed: {
    ...mapGetters( { user: ["auth/user"] }),
  },
  methods: {
    goToLogin: () => {
      self.$router.replace("/signin")
    },
    submit: () => {
      let { user, pin, password, $router } = self
      self.$store.dispatch('auth/resetPassword', { user, pin, password, $router }).catch(error=> {
        self.showMessage(error.message);
      })
    },
    resendConfirmationCode: () => {
      let { user = { username: ''}} = self
      self.$store.dispatch('auth/resendSignUp', { user }).then(()=> {
        self.showMessage("Código reenviado");
      }).catch(error => {
        self.showMessage(error.message);
      })
    },
    showMessage: (message) => {
      self.message = message;
      if (self.messageFn){
        clearTimeout(self.messageFn);
        self.messageFn = null
      }
      self.messageFn = setTimeout( ()=> { self.message = ""; }, 5000)
    }
  }  
  
};
</script>
